
#include "parsehtm.h"
#include <stdio.h>

void areaHandler(String ts,String as,String et,Dictionary td)
{
	String value;
	
	value = dict_valueForKey(td,"ROWS");
	
	if(value)
	{
		string_setStringValue(value,"5");
	}
	else
	{
		value = string_alloc(2);
		string_setStringValue(value,"5");
		dict_setValueForKey(td,"ROWS",value);
	}
	
	value = dict_valueForKey(td,"COLS");
	
	if(value)
	{
		string_setStringValue(value,"30");
	}
	else
	{
		value = string_alloc(3);
		string_setStringValue(value,"30");
		dict_setValueForKey(td,"COLS",value);
	}

    value = stringForTagDict(td);
	
	if(value)
	{
		string_setStringValue(ts,value->string);
		string_appendString(ts,"This is the new text.\nThe size should be 30X5.");
		if(et && et->string) string_appendString(ts,et->string);
		else string_appendString(ts,"</TEXTAREA>");
		
		string_free(value);
	}
}

void main(int argc, char *argv[])
{
	String output;
	String endTag;
	
	initializeHtmlParsingLibrary();
	
	endTag = string_alloc(12);
	string_setStringValue(endTag,"</TEXTAREA>");
	
	dict_setValueForKey(handlerDict,"TEXTAREA",areaHandler);
	dict_setValueForKey(endTags,"TEXTAREA", endTag);
		
	output = parseHtml("area_c.htm");
	
	if(output && output->string)
	{
		printf("Content-type: text/html\n\n");
		fwrite(output->string,sizeof(char),strlen(output->string),stdout);
		printf("\n");
		
		string_free(output);
	}
	
	exit(0);
}



